From 6ba262f630f8fed6753ab2ada337924215f593c6 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 27 2020 08:54:53 +0000
Subject: [PATCH 1793/2232] Emit private layout struct for all opaque types


---

diff --git a/gen/src/write.rs b/gen/src/write.rs
index 86fd491..507649e 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -311,22 +311,32 @@ fn write_opaque_type<'a>(out: &mut OutFile<'a>, ety: &'a ExternType, methods: &[
     for line in ety.doc.to_string().lines() {
         writeln!(out, "//{}", line);
     }
+
     out.builtin.opaque = true;
-    write!(
+    writeln!(
         out,
         "struct {} final : public ::rust::Opaque {{",
         ety.name.cxx,
     );
+
     for method in methods {
-        write!(out, "\n  ");
+        write!(out, "  ");
         let sig = &method.sig;
         let local_name = method.name.cxx.to_string();
         write_rust_function_shim_decl(out, &local_name, sig, false);
-        write!(out, ";");
+        writeln!(out, ";");
     }
+
     if !methods.is_empty() {
         writeln!(out);
     }
+
+    out.include.cstddef = true;
+    writeln!(out, "private:");
+    writeln!(out, "  struct layout {{");
+    writeln!(out, "    static ::std::size_t size() noexcept;");
+    writeln!(out, "    static ::std::size_t align() noexcept;");
+    writeln!(out, "  }};");
     writeln!(out, "}};");
     writeln!(out, "#endif // {}", guard);
 }

